package cz.cuni.mff.nprg013.tests.robots.model;

import java.util.ArrayList;
import java.util.List;

public class RobotModels {
    private static RobotModels instance;

    private List<RobotModel> robots = new ArrayList<>();
    private int nextID = 0;
    
    public static synchronized RobotModels getInstance() {
        if (instance == null) {
            instance = new RobotModels();
        }
        return instance;
    }
    
    
    private RobotModels() {
    }


    public List<RobotModel> getRobots() {
        return robots;
    }
    
    public RobotModel getRobotById(String id) {
        for(RobotModel robot : robots) {
            if (robot.getId().equalsIgnoreCase(id)) {
                return robot;
            }
        }
        return null;
    }
    public synchronized RobotModel newRobot(String name) {
        RobotModel robot = new RobotModel(String.valueOf(nextID), name, new Maze(), robots);
        nextID++;
        robots.add(robot);
        return robot;
    }
    
    public static void main(String[] args) {
        RobotModels rms = RobotModels.getInstance();
        Maze m = new Maze();
        
        RobotModel r = new RobotModel("01", "test", m, rms.getRobots());
        r.addAction(Actions.FIRE);
        r.addAction(Actions.TURN_RIGHT);
        r.addAction(Actions.FIRE);
        r.addAction(Actions.TURN_RIGHT);
        r.addAction(Actions.FIRE);
        r.addAction(Actions.TURN_RIGHT);
        r.addAction(Actions.FIRE);
        r.addAction(Actions.TURN_RIGHT);
        
        rms.getRobots().add(r);
        
        Scheduler s = new Scheduler();
        s.runSimulation();
    }

    
}

